%define php_apiv  %((echo 0; php -i 2>/dev/null | grep "PHP API"        | tr -d '[:alpha:][:punct:][:blank:]') | tail -1)
%define php_zendv %((echo 0; php -i 2>/dev/null | grep "PHP Extension"  | tr -d '[:alpha:][:punct:][:blank:]') | tail -1)
%define php_zendx %((echo 0; php -i 2>/dev/null | grep "Zend Extension" | tr -d '[:alpha:][:punct:][:blank:]') | tail -1)
%define php_ver   %(php-config --version 2>/dev/null || echo 0)
%define php_extd  %(php-config --extension-dir 2>/dev/null || echo 'None')

%define mod_name  xcache
%define mod_ver   1.3.1

%define sel_modn  selinux-policy-addon
%define sel_modv  0.2.5


Summary:          A fast open source PHP opcode cacher
Name:             php-%{mod_name}
Version:          %{mod_ver}
Release:          1%{?dist}%{?pext}
License:          BSD
Group:            System Environment/Libraries
Source0:          http://%{mod_name}.lighttpd.net/pub/Releases/%{mod_ver}/%{mod_name}-%{mod_ver}.tar.gz
Source1:          %{name}.ini
Source2:          %{name}.conf
Patch0:           %{mod_name}-1.3.0-paths.patch
URL:              http://%{mod_name}.lighttpd.net/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           mOo <phpxcache@gmail.com>
Provides:         php-accelerator
Requires:         php = %{php_ver}
Requires(postun): /sbin/service
BuildRequires:    automake libtool m4 php-devel >= 4

%description
XCache is a fast, stable and open-source PHP opcode cacher, which means that
it accelerates the performance of PHP on servers. It optimizes performance by
removing the compilation time of PHP scripts by caching the compiled state of
PHP scripts into shared memory and uses the compiled version from there. This
will increase the rate of page generation as it also optimizes other aspects
of PHP scripts and reduce serverload.


%package          selinux
Summary:          SELinux support for %{name}
Group:            System Environment/Base
Requires:         %{name} = %{version}-%{release}
Requires:         %{sel_modn} >= %{sel_modv}
Requires(post):   /sbin/restorecon %{_sbindir}/selinuxenabled /sbin/fixfiles

%description      selinux
This package enables %{name} to work with SELinux.


%prep
%setup -q -n %{mod_name}-%{mod_ver}
%patch0 -p1


%build
export CFLAGS="${RPM_OPT_FLAGS} -I%{_includedir}/php/ext/date/lib -fno-strict-aliasing"
phpize

%configure \
	--enable-xcache=shared   \
	--enable-xcache-constant \
	--enable-xcache-coverager

%{__make} %{?_smp_mflags}


%check
%{__make} xcachetest


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/php.d
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{mod_name}/scripts
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/cache/%{mod_name}/{coredump,coverage}

%{__make} \
	INSTALL_ROOT=${RPM_BUILD_ROOT} \
	install

%{__install} -m 0644 %{SOURCE1}  ${RPM_BUILD_ROOT}%{_sysconfdir}/php.d/%{mod_name}.ini
%{__install} -m 0644 %{SOURCE2}  ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/%{mod_name}.conf

%{__install} -m 0640 coverager/* ${RPM_BUILD_ROOT}%{_datadir}/%{mod_name}/scripts
%{__install} -m 0640 admin/*     ${RPM_BUILD_ROOT}%{_datadir}/%{mod_name}/scripts


%post selinux
if /usr/sbin/selinuxenabled && [ -e /selinux/policyvers ]; then
  /sbin/fixfiles   -R %{name} restore
  /sbin/restorecon -R %{_localstatedir}/cache/%{mod_name}
fi


%postun
# Restart after erase/upgrade
/sbin/service httpd condrestart >/dev/null 2>&1 || :


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README THANKS
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{mod_name}.conf
%config(noreplace) %{_sysconfdir}/php.d/%{mod_name}.ini
%{php_extd}/%{mod_name}.so
%dir %{_datadir}/%{mod_name}
%attr(750,root,apache) %dir %{_datadir}/%{mod_name}/scripts
%attr(640,root,apache) %config(noreplace) %dir %{_datadir}/%{mod_name}/scripts/*
%attr(750,apache,apache) %dir %{_localstatedir}/cache/%{mod_name}
%attr(750,apache,apache) %dir %{_localstatedir}/cache/%{mod_name}/coredump
%attr(750,apache,apache) %dir %{_localstatedir}/cache/%{mod_name}/coverage

%files selinux
%defattr(-,root,root)


%changelog
* Tue Dec 21 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.1-1
- New version (1.3.1)

* Thu Apr 15 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.0-1
- Initial build
